function heMatrix = mapToProperEmbedding(hcMatrix, dec, zerotol, ...
    partitionVector)
% map hC-vector to the correspondent in embedding proper representation
%
% Syntax: heMatrix = convertToProperEmbedding(hcMatrix, dec)
%
% The resulting hE-vector is always valid.
%
% See also: obtainDec, mapFromProperEmbedding

% The elk-library: convex geometry applied to crystallization modeling.
%   Copyright (C) 2014 Alexander Reinhold
%
% This program is free software: you can redistribute it and/or modify it 
%   under the terms of the GNU General Public License as published by the 
%   Free Software Foundation, either version 3 of the License, or (at your 
%   option) any later version.
%
% This program is distributed in the hope that it will be useful, but 
%   WITHOUT ANY WARRANTY; without even the implied warranty of 
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
%   General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
%   with this program.  If not, see <http://www.gnu.org/licenses/>.

if ~exist('zerotol', 'var') || isempty(zerotol)
    zerotol = elkZerotol;
end
if ~exist('partitionVector', 'var') || isempty(partitionVector)
    partitionVector = computePartitionIndexDec(dec, hcMatrix, zerotol, 1);
end

heMatrix = dec.properData.mappingNewToProper * hcMatrix;
% if decomposition is not complete, we have already finished
if ~dec.isComplete,return;end

for iPart = 1:dec.nPU
    thisFilter = partitionVector == iPart;
    heMatrix(:, thisFilter) = ...
        dec.unifiedPartition{iPart}.projection.validity * ...
        heMatrix(:, thisFilter);
end